---
layout: post
title: Leaflet 0.7.5 Release
description: Leaflet 0.7.5 released, containing bugfixes and backports.
author: Iván Sánchez Ortega
---

While the Leaflet development team is busy with the 1.0 betas, there have been a few bugs affecting 0.7.3, important enough to spend some effort in porting a fix back. They are not much, though:

- Workarounds for issues derived from new browsers (touch-capable browsers, tile loading in recent Chrome)
- Backport fixes for styling and events for canvas-based vector layers
- Fix edge cases involving `maxZoom`, `minZoom`, `maxNativeZoom` on tile layers and popup events
- Revert a regression bug in 0.7.4 which conflicted with marker clusters

The detailed list of changes can be found [in the changelog](https://github.com/Leaflet/Leaflet/blob/master/CHANGELOG.md#074-sep-01-2015)

The fact that it has been over *a year and half* since the last stable release should be a testament of the quality and stability of the Leaflet API. If you think that development of Leaflet 1.0 is taking a long time, remember that we want to keep the same level of quality for the final 1.0 release.

The 0.7.x releases will not implement new features. Stay tuned for more news on the 1.0 beta releases instead!


### Get the update

Developers using Leaflet 0.7.3 are advised to upgrade to 0.7.5 to prevent problems arising from modern browers.

The release is also available through NPM, Bower, [direct download](http://cdn.leafletjs.com/downloads/leaflet-0.7.5.zip), or through our CDN:

    <link rel="stylesheet" href="cdn.leafletjs.com/leaflet-0.7.5/leaflet.css" />
    <script src="http://cdn.leafletjs.com/leaflet-0.7.5/leaflet.js"></script>
